﻿Type=Activity
Version=1.70
FullScreen=False
IncludeTitle=True
@EndOfDesignText@
' actSqlView v. 1.01
' Variables to be set in the caller prg:
'	pSqlRitornoV=FALSE : flag that tells the caller prg that should process the data returned (click on a cell) (always FALSE to entry)
'	pSqlLimite=pSqlLimiteDefault : value of 'LIMIT'; pSqlLimiteDefault is the default configured in fixed mode or in config table
'	pSqlHeightRowTab=0 : height of the rows of the list (the font size is not changed), 0 = default row height
'	pSqlTab=1 : no. the table to be processed
' pSqlZoomEnabled=True : enable / disable zoom
' pSqlElencoClick=True : enables / disables the click in the list of records
' pSqlOrderClick=True : enables / disables the possibility of practicing change the order by (so table header clickable)
'	pSqlSelect="SELECT id as '0§Progr§right§FF0000§FFFFFF§false', id as '1§ID§left§0§0§true', descriz as '2§des§left§1§FFFF00§true', data1 as '3§data§center§0§0§true', numerodec as '4§numero dec§right§00FF00§COCOCO§true', testogen as '5§testo§left§0§0§false'"
' ' select statement with the following data to be processed : §=asc(167)
'		x1§x2§x3§x4§x5§x6  Ex: '0§Progr§right§FF0000§FFFFFF§false'
'		x1=no. field in the table (if = 0 is automatically added as the first column, nr. Progressive / row of the query records
'		x2=description of the column
'		x3=alignment : left, center, right
'		x4=color (in hex) of the background of the column, if 0 = default color
'		x5=color (in hex) character of the column (where 0 = default color)
'		x6=flag to indicate if the column is clickable for sorting, can assume TRUE/FALSE
'	pSqlFrom=" FROM "&modFunc.NomeTabella(pSqlTab) : FROM statement
'	pSqlWhere="" : WHERE statement
'	pSqlOrderby=" order by id" : ORDER BY statement
'	pSqlGroupby="" : GROUP BY statement
'	' This is the query that will be performed: the return by activity (sub resume) will be re-run the query
'	pSqlQuery=pSqlSelect&pSqlFrom&pSqlWhere&pSqlOrderby&pSqlGroupby
'	StartActivity(actSqlView)
'
' da fare/TODO : 
' - condizioni per ciascuna colonna cambiandone i colori (es : if <nomecampo><0... background colore rosso e carattere colore bianco
' - abilita/disabilita zoom da bottone nella stessa videata actSqlView
' - abilita/disabilita LIMIT da bottone nella stessa videata actSqlView
' - evidenziare (dove possibile) l'ordinamento di ingresso
' - ordinamento colonne con più campi
'
'
'Activity module
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

End Sub
 
Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Dim QueryOrigine, OrderOrigine, HtmlCSS1 As String
	Dim xcampo(main.pmaxCampi+1), xtipoR(main.pmaxCampi+1), xtipoSql(main.pmaxCampi+1), header(main.pmaxCampi+1, 8), statoOrder(main.pmaxCampi+1) As String
	Dim xlen(main.pmaxCampi+1), xdec(main.pmaxCampi+1) As Int
	Dim LenTotFields, nrProgr, nrColonne, LenProgr, ncold As Int
	Dim cur1 As Cursor
	Dim btnPrecedente, btnSuccessivo, btnPrimo, btnUltimo As Button
	Dim wvHeader, wvTable As WebView
	Dim sbh As StringBuilder
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.LoadLayout("asqlview")
	' totale records senza LIMIT x, y
	queryReale="Select COUNT(*) As nrcol "&main.pSqlFrom&main.pSqlWhere
	cur1=main.SQL1.ExecQuery(queryReale)
	cur1.Position = 0
	main.pSqlTotRecords=cur1.GetInt("nrcol")
	cur1.Close
	Activity.Title=main.trans.GetText("Totale records : ")&main.pSqlTotRecords
	QueryOrigine=main.pSqlQuery ' query originale 
	OrderOrigine=main.pSqlOrderby
	main.pSqlLimiteMin=0
	main.pSqlLimiteMax=0
	Dim hh As Int
	hh=43 ' altezza table header
	wvHeader.SetLayout(0, 0, Activity.Width, hh) 
	wvHeader.ZoomEnabled=False
	wvTable.ZoomEnabled=main.pSqlZoomEnabled
	If main.pSqlLimite=0 Then
		wvTable.SetLayout(0, hh+1, Activity.Width, Activity.Height-hh-5)
		btnPrecedente.Visible=False
		btnSuccessivo.Visible=False
		btnPrimo.Visible=False
		btnUltimo.Visible=False
	Else
		wvTable.SetLayout(0, hh+1, Activity.Width, Activity.Height-hh-55)
		btnPrecedente.Visible=True		
		btnSuccessivo.Visible=True
		btnPrimo.Visible=True
		btnUltimo.Visible=True
	End If
	' estrapolazione dati dalla struttura tabella
	main.pTabellaOpz=Regex.Split(",", main.pFields(main.pSqlTab, 0))
	For t1=1 To main.pTabellaOpz(3)
		main.pFieldsOpz=Regex.Split(",", main.pFields(main.pSqlTab, t1))
		xcampo(t1)=main.pFieldsOpz(0)
		xtipoR(t1)=main.pFieldsOpz(1)
		xtipoSql(t1)=main.pFieldsOpz(2)
		xlen(t1)=main.pFieldsOpz(3)
		xdec(t1)=main.pFieldsOpz(4)
	Next
	HtmlCSS1 = "table {width:100%; background-color: #FFFFFF; border: 1px solid #C0C0C0; text-align: left; }"&CRLF
	HtmlCSS1 = HtmlCSS1&"td,th { padding: 5px 1px; font-family:verdana; border-bottom:1px solid #C0C0C0; border-left:1px solid #C0C0C0; }"&CRLF
	If main.pSqlHeightRowTab>0 Then
		HtmlCSS1 = HtmlCSS1&"td { height: "&main.pSqlHeightRowTab&"px; }"&CRLF
	End If
	HtmlCSS1 = HtmlCSS1&".intesta {font-weight:bold; font-family:verdana; color:#FFFF00; background-color: #00C000; }"&CRLF
	HtmlCSS1 = HtmlCSS1&".intesta a { text-decoration:underline; color: #FFFF00; }"&CRLF
	HtmlCSS1 = HtmlCSS1&".odd {background-color: #FFFFFF; }"&CRLF
	HtmlCSS1 = HtmlCSS1&".even {background-color: #CEFFCE; }"&CRLF
	HtmlCSS1 = HtmlCSS1&"a { text-decoration:none; color: #000000; }"&CRLF
	For i=0 To statoOrder.Length-1
		statoOrder(i)="O"
	Next
	' eseczione query necessaria per ricavare le info sulle colonne
	cur1 = main.SQL1.ExecQuery(QueryOrigine&" limit 1")
	cur1.Position = 0
	' preparazione istruzioni fisse : header table, intesta, etc...
	Dim xintesta() As String
	' header table
	ncold=0
	LenTotFields=0
	LenProgr=5
	nrColonne=cur1.ColumnCount
	' ciclo per assegnazioni e totalizzatori
	For i = 0 To cur1.ColumnCount - 1
		xintesta=Regex.Split("§", cur1.GetColumnName(i))
		header(i,1)=xintesta(0) ' nr. campo
		header(i,2)=xintesta(1) ' descrizione
		header(i,3)=xintesta(2) ' allineamento
		header(i,4)=xintesta(3) ' colore background
		header(i,5)=xintesta(4) ' colore foreground
		header(i,7)=xintesta(5).ToUpperCase ' possibilità di ordinamento
'		header(i,8)="N" ' colonna con decimali
		If xintesta(0)="0" Then
			' progressivo... campo fittizio con nr. 0
			LenTotFields=LenTotFields+LenProgr
		Else
			LenTotFields=LenTotFields+xlen(xintesta(0))
'			If xdec(xintesta(0))>0 Then
'				header(i,8)="S" ' colonna con decimali
'			End If
		End If
	Next
	cur1.Close
	HtmlwvHeader ' pagina html webviwer dell'header
	ElaboraElenco("S")
End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub Activity_KeyPress (KeyCode As Int) As Boolean 'return true if you want to consume the event
	' keycode 82 = menu
	' keycode  4 = indietro
	' keycode 84 = search
	' Msgbox("--->" & KeyCode, "tasto...")

'	If fsound="B" Then sounds.Play(sndFuori, 1, 1, 0, 0, 1)
	If KeyCode=4 Then ' indietro
		main.pSqlRitornoV=False
	End If
	
End Sub

Sub Activity_Touch (Action As Int, X As Float, Y As Float)
	'Log("action="&action&"-x="&x&"-y="&y)
	
	' beep per pressione fuori dai bottoni
'	If fsound="B" Then sounds.Play(sndFuori, 1, 1, 0, 0, 1)

End Sub

Sub btnPrecedente_Click
	' precedenti xxx records	
	ElaboraElenco("P")
End Sub

Sub btnSuccessivo_Click
	' successivi xxx records	
	ElaboraElenco("S")
End Sub

Sub btnPrimo_Click
	' primo blocco
	main.pSqlLimiteMin=0
	main.pSqlLimiteMax=main.pSqlLimite
	ElaboraElenco("I")
End Sub

Sub btnUltimo_Click
	' ultimo blocco
	If (main.pSqlTotRecords Mod main.pSqlLimite)=0 Then
		main.pSqlLimiteMin=main.pSqlTotRecords-main.pSqlLimite
	Else
		main.pSqlLimiteMin=main.pSqlTotRecords-(main.pSqlTotRecords Mod main.pSqlLimite)
	End If
	main.pSqlLimiteMax=main.pSqlTotRecords
	ElaboraElenco("U")
End Sub

Sub ElaboraElenco(PrecSucc As String)
	' se attivato il limite
'	If main.fsound="B" Then main.sounds.Play(main.sndTick, 1, 1, 0, 0, 1)
	If main.pSqlLimite>0 Then
		If PrecSucc="S" Then 		
			main.pSqlLimiteMin=main.pSqlLimiteMax
			main.pSqlLimiteMax=main.pSqlLimiteMin+main.pSqlLimite
		End If
		If PrecSucc="P" Then 		
			main.pSqlLimiteMin=main.pSqlLimiteMin-main.pSqlLimite
			main.pSqlLimiteMax=main.pSqlLimiteMin+main.pSqlLimite
		End If
		' controlli validità limiti
		If main.pSqlLimiteMin<=0 Then 
			main.pSqlLimiteMin=0
			btnPrecedente.Visible=False
			btnPrimo.Visible=False
		Else
			btnPrecedente.Visible=True
			btnPrimo.Visible=True
		End If
		If main.pSqlLimiteMax>=main.pSqlTotRecords Then 
			main.pSqlLimiteMax=main.pSqlTotRecords
			btnSuccessivo.Visible=False
			btnUltimo.Visible=False
		Else
			btnSuccessivo.Visible=True
			btnUltimo.Visible=True
		End If
'		TestoSucc=main.pSqlLimiteMax-main.pSqlLimiteMin
'		If main.pSqlLimiteMax+main.pSqlLimite>=main.pSqlTotRecords Then
'			TestoSucc=main.pSqlTotRecords-main.pSqlLimiteMax  'in-main.pSqlLimite
'		End If
		main.pSqlQuery=QueryOrigine&" limit "&main.pSqlLimiteMin&", "&main.pSqlLimite
	End If
	wvTable.LoadHtml(ExecuteHtml1(main.SQL1, main.pSqlQuery, main.pSqlElencoClick))
End Sub

Sub ExecuteHtml1(xSQL As SQL, xQuery As String, Clickable As Boolean) As String
	' istruzioni html per la query in esecuzione
	ProgressDialogShow("Query...")
	cur1 = xSQL.ExecQuery(xQuery)
	'
	Dim sb As StringBuilder
	Dim nc As Int
	sb.Initialize
	sb.Append("<html><body>").Append(CRLF)
	sb.Append("<style type='text/css'>").Append(HtmlCSS1).Append("</style>").Append(CRLF)
	sb.Append("<table>").Append(CRLF)
	For row = 0 To cur1.RowCount-1
		cur1.Position = row
		If row Mod 2 = 0 Then
			sb.Append("<tr class='even'>")
		Else
			sb.Append("<tr class='odd'>")
		End If
		For i = 0 To cur1.ColumnCount - 1
			nc=header(i, 1) ' nr.campo
			sb.Append("<td width=").Append(header(i,6)).Append("% align=").Append(header(i,3))
			' colore sfondo
			If header(i, 4)<>"0" Then
				sb.Append(" bgcolor='#").Append(header(i,4)).Append("'")
			End If
			sb.Append(">")
			If nc=0 Then
				' progressivo riga
				dato=row+main.pSqlLimiteMin+1
			Else
				dato=cur1.GetString2(i)
				If nc>0 AND xtipor(nc)="N" AND xdec(nc)>0 Then
					dato=modFunc.NumDecimal(dato, xdec(nc))
				End If
				If nc>0 AND xtipor(nc)="D" Then
					dato=modFunc.ConvData(dato, "yyyy-MM-dd", main.pDateFormat)
				End If
			End If			
			If Clickable=True Then
				sb.Append("<a href='http://").Append(i).Append(".").Append(row).Append(".com'>")
			End If
			' colore carattere
			If header(i, 5)<>"0" Then
				sb.Append("<font color='#").Append(header(i,5)).Append("'>")
			End If
			sb.Append(dato)
			If header(i, 5)<>"0" Then
				sb.Append("</font>")
			End If
			If Clickable=True Then
				sb.Append("</a>")
			End If
			sb.Append("</td>")
		Next
		sb.Append("</tr>").Append(CRLF)
	Next
	cur1.Close
	sb.Append("</table>").Append("</body></html>").Append(CRLF)
	If main.pSqlLimite>0 Then 
		Activity.Title=main.trans.GetText("Records da ")&main.pSqlLimiteMin&main.trans.GetText(" a ")&main.pSqlLimiteMax&main.trans.GetText(" di ")&main.pSqlTotRecords
	End If
	ProgressDialogHide
	Return sb.ToString
End Sub

Sub wvHeader_OverrideUrl (Url As String) As Boolean
	' parse la riga/colonna dell'intestazione dall'url
	Dim values() As String
	values = Regex.Split("[.]", URL.SubString(7))
	' valori da utilizzare per l'ordinamento
	Dim nc As Int
	Dim xord As String
	nc=values(1)
	xord=""
	' stato order per ciascun campo della query : ciclico = O-A-D-O
	If ncold<>nc Then
		' ripristino flag campo precedentemente cliccato
		statoOrder(ncold)="O"
	End If
	ncold=nc
	Select statoOrder(nc)
		Case "O"
			' si passa ad Asc
			xord=values(0)&" ASC"
			statoOrder(nc)="A"
		Case "A"
			' si passa ad Desc
			xord=values(0)&" DESC"
			statoOrder(nc)="D"
		Case "D"
			' ritorno all'originale
			xord=""
			statoOrder(nc)="O"
	End Select
	If xord<>"" Then
		main.pSqlOrderby=" order by "&xord
	Else
		main.pSqlOrderby=OrderOrigine
	End If
	main.pSqlQuery=main.pSqlSelect&main.pSqlFrom&main.pSqlWhere&main.pSqlOrderby&main.pSqlGroupby
	QueryOrigine=main.pSqlQuery
	HtmlwvHeader
	ElaboraElenco("X") ' 
End Sub

Sub wvHeader_PageFinished (Url As String)

End Sub

Sub wvTable_OverrideUrl (Url As String) As Boolean
	' parse la riga/colonna dell'intestazione dall'url
'	If main.fsound="B" Then main.sounds.Play(main.sndTick, 1, 1, 0, 0, 1)
	Dim values() As String
	values = Regex.Split("[.]", URL.SubString(7))
	' valori da ritornare
	main.pSqlnCampo = values(0)
	main.pSqlnRecord = values(1)
	main.pSqlRitornoV=True
	Activity.Finish
	Return True 
End Sub

Sub wvTable_PageFinished (Url As String)
	
End Sub

Sub HtmlwvHeader
	' istruzioni html
	Dim nc1 As Int
	sbh.Initialize
	sbh.Append("<html><body>").Append(CRLF)
	sbh.Append("<style type='text/css'>").Append(HtmlCSS1).Append("</style>").Append(CRLF)
	sbh.Append("<table><tr class='intesta'>")
	For i = 0 To nrColonne - 1
		' calcolo % e pixel per larghezza ciascuna colonna
		nc1=header(i,1) ' nr.campo
		If nc1=0 Then
			perc=LenProgr/LenTotFields*100  ' progressivo
		Else
			perc=xlen(nc1)/LenTotFields*100
		End If
		header(i,6)=perc
		sbh.Append("<td width=").Append(header(i,6)).Append("% align=").Append(header(i,3)).Append(">")
		' link per ordinamento
		If main.pSqlOrderClick=True AND header(i, 7)="TRUE" AND nc1>0 Then ' "TRUE" intesa come stringa!!!
			If statoOrder(nc1)="A" Then
				xico=" <img src='File:///android_asset/freccia_su.png' width='20' height='20' align='absmiddle'>"
			End If
			If statoOrder(nc1)="D" Then
				xico=" <img src='File:///android_asset/freccia_giu.png' width='20' height='20' align='absmiddle'>"
			End If
			If statoOrder(nc1)="O" Then
				xico=""
			End If
			sbh.Append("<a href='http://").Append(xcampo(nc1)).Append(".").Append(i).Append(".com'>").Append(header(i, 2)).Append(xico).Append("</a>")
		Else
			sbh.Append(header(i, 2))
		End If
		sbh.Append("</td>")
	Next
	sbh.Append("</tr></table></body></html>").Append(CRLF)
	wvHeader.LoadHtml(sbh.ToString)
End Sub
